// Colour.h: Interface for the Colour class.
//			 This class stores the representation of a colour 
//			 and provides override operators too perform arithmetic
//			 on the colour values.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLOUR_H__CCFA72B3_EDE3_4F71_AA3C_C49A92643DDC__INCLUDED_)
#define AFX_COLOUR_H__CCFA72B3_EDE3_4F71_AA3C_C49A92643DDC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class Colour  
{
public:
	// RGB values
	double R, G, B;

	// Constructors & destructor
	Colour();
	virtual ~Colour();
	Colour(const double r, const double g, const double b);

	// Set Methods
	void Set(const double r, const double g, const double b);
    
	// Operations
	friend Colour operator * (const double s, const Colour c);
	Colour& operator=(const Colour& c);
	Colour operator * (const Colour& c);
	void operator *= (const double s);
    void operator /= (const double s);
    void operator += (const Colour c);
	void Bind();
	
	Colour Mult(const Colour &c);
	void MultScalar(const double a);	
};

#endif // !defined(AFX_COLOUR_H__CCFA72B3_EDE3_4F71_AA3C_C49A92643DDC__INCLUDED_)

