// HitObject.h: Interface for the HitObject class.
//				This class stores the representation of a hit object
//				This includes the actual point on the object where
//				the hit occured, the normal vector at this point, 
//				and the time t of the hit.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_HITOBJECT_H__6E836EC5_32EF_4680_ACFD_104CFF67585A__INCLUDED_)
#define AFX_HITOBJECT_H__6E836EC5_32EF_4680_ACFD_104CFF67585A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Ray.h"

class HitObject  
{
public:
	Vec3 normal;	// normal
	Vec4 hit;		// hit point where ray and object intersect
	double t;		// time of hitpoint

	// Constructors & Destructor
	HitObject();
	HitObject(const HitObject& ho);
	virtual ~HitObject();
	
	// Set Methods
	void Set(const HitObject& ho);
	void Set(const Ray ray, const double T, const Vec4 C);
    void Set(const Ray ray, const double T, const Vec3 N);

	// Method to transform the normal
	Vec3 TransformNormal(const Matrix &T) const;
};

#endif // !defined(AFX_HITOBJECT_H__6E836EC5_32EF_4680_ACFD_104CFF67585A__INCLUDED_)

