// SurfaceModel.h: Interface for the SurfaceModel class.
//				   This class contains the surface properties for
//				   and object.
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SURFACEMODEL_H__E14114C9_DA9D_48D7_88D8_FCDFC55748C8__INCLUDED_)
#define AFX_SURFACEMODEL_H__E14114C9_DA9D_48D7_88D8_FCDFC55748C8__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Colour.h"

class SurfaceModel  
{
public:
	// Ambient, Diffuse and Specular components
	Colour Diffuse;
	Colour Ambient;
	Colour Specular;

	double RefractionIndex;
	double Reflective;
	double Transparent;
    double SpecExponent;

	// Constructors and Destructor
	SurfaceModel();

	SurfaceModel(const Colour Ambient, const Colour Diffuse, const Colour Specular,
		double Reflective, double Transparent, double RefractionIndex, double SpecExp);

	SurfaceModel(const SurfaceModel& surface);
	
	virtual ~SurfaceModel();

	// Set Method
	void Set(const SurfaceModel& surface);
};

#endif // !defined(AFX_SURFACEMODEL_H__E14114C9_DA9D_48D7_88D8_FCDFC55748C8__INCLUDED_)

