///////////////////////////////////////////////////////
// CSC418 Project - Ray Tracer - Dec 5, 2001
// Nelson Arruda - 980479290
// Michael Scrivo - 980473300
// See Readme.txt for details
///////////////////////////////////////////////////////

#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include "RayTracer.h"
#include <stdio.h>

RayTracer RT;

void display ();
void handleReshape(int w, int h);

int main(int argc, char *argv[]) 
{
	// Test builds the scene for rendering
	RT.Test(1, 3);

	glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGBA | GLUT_DEPTH);
	glutInitWindowPosition (0, 0);
	glutInitWindowSize(RT.Width, RT.Height);
	int mainWindowID = glutCreateWindow(argv[0]);

	glutReshapeFunc (handleReshape);
	glutDisplayFunc(display);
	glutMainLoop();

	return 0;
}

void handleReshape(int w, int h) {
  RT.Width  = w;
  RT.Height = h;

  //
  // Set the viewport
  //
  glViewport(0, 0, w, h);

  // resize the image to fit the screen.

  if (RT.img != NULL)
	delete []RT.img;

  RT.img = new byte[RT.Width*RT.Height*3];

  RT.CastRays();

  //
  // Now start setting the projection matrix stack
  //
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  float dx = (RT.xMax-RT.xMin)/2.0;
  float dy = (RT.yMax-RT.yMin)/2.0;
  glOrtho(-dx,dx, -dy,dy, 0.1, 2.0);

}

void display () {
	glClearColor(.1f,.1f,.1f, 1.f);   /* set the background colour */
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	gluLookAt((RT.xMin+RT.xMax)/2.0, (RT.yMin+RT.yMax)/2.0, 1,
            (RT.xMin+RT.xMax)/2.0, (RT.yMin+RT.yMax)/2.0, 0.0,
            0.0, 1.0, 0.0);

	glRasterPos3d(RT.xMin,RT.yMin,0.0);

	glDrawPixels(RT.Width,RT.Height, GL_RGB, GL_UNSIGNED_BYTE, RT.img);

	glFlush();
	glutSwapBuffers();
}
